/* Test Application that uses the Python Interpreter */

#define SFVARNAME "SCRFNAME"  /* Script Filename Variable Name */

#include <Python.h>

int main (argc, argv)
  int argc;
  char **argv;

{
  char *fname;
  FILE *fp;
  PyObject *locals, *globals, *pobj;

  printf ("Initialize Python Interpreter\n");
  Py_Initialize ();
  if (argc > 1)
    {
      fname = argv [1];
      if (fp = fopen (fname, "r"))
        {
          printf ("Provide global and local Dictionaries\n");
          locals = PyDict_New ();
          globals = PyDict_New ();
          printf ("Provide Script Name %s\n", fname);
          pobj = PyString_FromString (fname);
          if (PyDict_SetItemString (globals, SFVARNAME, pobj))
            printf ("Cannot set Script Name !\n");
          printf ("Run Python Script %s\n", fname);
          pobj = PyRun_File (fp, fname, Py_file_input, globals, locals);
          fclose (fp);
          if (pobj)
            if (pobj == Py_None)
              printf ("The Python Script did not return a Result\n");
            else
              {
                fname = PyString_AsString (pobj);
                printf ("Python Script Result = %s\n", fname);
              }
          else
            printf ("Python Script could not be run successfully !\n");
        }
      else
        printf ("Python Script %s not found !\n", fname);
    }
  else
    {
      printf ("Run Python Script\n");
      PyRun_SimpleString ("print 'Test'");
    }
  printf ("Finalize Python Interpreter\n");
  Py_Finalize ();
  printf ("Exit\n");
  return (0);
}
