/* Python Module pyhello */

#include <Python.h>

#define MYNAME  "ELUG"
#define MYVALUE 123

staticforward PyTypeObject pyhello_MyDataType;

typedef struct
  {
    PyObject_HEAD
    PyObject *val;
  }
  pyhello_MyDataObject;

static PyObject *pyhello_new_mydata (self, args)
  PyObject *self, *args;

{
  PyObject *obj;
  pyhello_MyDataObject *mydata;

  obj = NULL;
  if (PyArg_ParseTuple (args, ":new_mydata"))
    {
      printf ("pyhello_new_mydata(): Create MyData Object\n");
      mydata = PyObject_New (pyhello_MyDataObject, &pyhello_MyDataType);
      printf ("pyhello_new_mydata(): Initialize Value\n");
      mydata->val = Py_BuildValue ("s", "[UninitializedValue]");
      obj = (PyObject *) mydata;
    }
  else
    printf ("pyhello_new_mydata(): Cannot create MyData Object !\n");
  return (obj);
}

static void pyhello_mydata_dealloc (self)
  PyObject *self;

{
  pyhello_MyDataObject *mydata;

  printf ("pyhello_mydata_dealloc(): Deallocate MyData Object\n");
  mydata = (pyhello_MyDataObject *) self;
  Py_DECREF (mydata->val);
  mydata->val = NULL;
  PyObject_Del (self);
}

static PyObject *pyhello_mydata_str (self)
  PyObject *self;

{
  pyhello_MyDataObject *mydata;

  mydata = (pyhello_MyDataObject *) self;
  Py_INCREF (mydata->val);
  return (mydata->val);
}

static PyObject *pyhello_mydata_get (self, args)
  PyObject *self, *args;

{
  PyObject *obj;

  obj = NULL;
  if (PyArg_ParseTuple (args, ":get"))
    obj = pyhello_mydata_str (self);
  return (obj);
}

static PyObject *pyhello_mydata_set (self, args)
  PyObject *self, *args;

{
  PyObject *val, *sobj;
  pyhello_MyDataObject *mydata;

  val = NULL;
  mydata = (pyhello_MyDataObject *) self;
  if (PyArg_ParseTuple (args, "S:set", &sobj))
    {
      Py_DECREF (mydata->val);
      Py_INCREF (mydata->val = sobj);
      val = Py_None;
    }
  return (val);
}

static PyObject *pyhello_mydata_call (self, args, other)
  PyObject *self, *args, *other;

{
  PyObject *obj;
  char *s;

  printf ("pyhello_mydata_call(): Call MyData Object\n");
  obj = NULL;
  if (PyArg_ParseTuple (args, ":call"))
    {
      printf ("pyhello_mydata_call(): Call without Parameters\n");
      obj = Py_None;
    }
  else
    if (PyArg_ParseTuple (args, "s:call", &s))
      {
        printf ("pyhello_mydata_call(): Call with Parameter %s\n", s);
        obj = Py_BuildValue ("s", s);
      }
  return (obj);
}

static PyMethodDef mydatamethods [] =
  {
    { "get", pyhello_mydata_get, METH_VARARGS, "Get MyData Value" },
    { "set", pyhello_mydata_set, METH_VARARGS, "Set MyData Value" },
    { NULL,  NULL,               0,            NULL               }
  };

static PyObject *pyhello_mydata_getattr (self, name)
  PyObject *self;
  char *name;

{
  return (Py_FindMethod (mydatamethods, self, name));
}

static PyTypeObject pyhello_MyDataType =
  {
    PyObject_HEAD_INIT (NULL)
    0,                              /* ob_size */
    "MyData",                       /* tp_name */
    sizeof (pyhello_MyDataObject),  /* tp_basicsize */
    0,                              /* tp_itemsize */
    /* Methods */
    pyhello_mydata_dealloc,         /* tp_dealloc */
    0,                              /* tp_print */
    pyhello_mydata_getattr,         /* tp_getattr */
    0,                              /* tp_setattr */
    0,                              /* tp_compare */
    pyhello_mydata_str,             /* tp_repr */
    0,                              /* tp_as_number */
    0,                              /* tp_as_sequence */
    0,                              /* tp_as_mapping */
    0,                              /* tp_hash  */
    pyhello_mydata_call,            /* tp_call */
    pyhello_mydata_str,             /* tp_str */
    0,                              /* tp_getattro */
    0,                              /* tp_setattro */
    0,                              /* tp_as_buffer */
    0,                              /* tp_flags */
    "MyData Type",                  /* tp_doc */
    /* Remaining Fields = 0 */
  };

static PyObject *pyhello_hello (self, args)
  PyObject *self, *args;

{
  return (Py_BuildValue ("s", "Hello, World !"));
}

static PyMethodDef pyhello_methods [] =
  {
    { "MyData", pyhello_new_mydata, METH_VARARGS, "Create MyData Object" },
    { "hello",  pyhello_hello,      METH_VARARGS, "Say Hello"            },
    { NULL,     NULL,               0,            NULL                   }
  };

DL_EXPORT (void) initpyhello ()

{
  PyObject *mod, *dict;

  printf ("initpyhello(): Initialize Module PySpam\n");
  pyhello_MyDataType.ob_type = &PyType_Type;
  mod = Py_InitModule ("pyhello", pyhello_methods);
  dict = PyModule_GetDict (mod);
  PyDict_SetItemString (dict, "MYNAME", Py_BuildValue ("s", MYNAME));
  PyDict_SetItemString (dict, "MYVALUE", Py_BuildValue ("i", MYVALUE));
}
