# -*- coding: utf-8 -*-
import gtk
import gobject

class Fenster:
    def __init__(self):
        self.__window = gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.__window.connect("destroy", self.__destroy)
        self.__window.set_size_request(450, 400)
        hpane = gtk.HPaned()
        sw = self.create_scroller()
        hpane.add1(sw)
        nb = self.create_notebook()
        hpane.add2(nb)
        self.__window.add(hpane)
        self.__window.show_all()
        gtk.main()

    def __destroy(self, widget, data=None):
        self.__window.hide()
        gtk.main_quit()

    def __eintragen(self, widget, data=None):
        buffy = self.__t1.get_buffer()
        start, end = buffy.get_bounds()
        print "(%d) - %s\n%s" % (self.__s1.get_value_as_int(), self.__e1.get_text(), buffy.get_text(start, end, False))
        iter = self.__model.append()
        self.__model.set (iter, 0, self.__s1.get_value_as_int(), 1, self.__e1.get_text())

    def create_scroller(self):
        scrolled_window = gtk.ScrolledWindow()
        scrolled_window.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        self.__model = gtk.ListStore(gobject.TYPE_INT, gobject.TYPE_STRING)
        tree_view = gtk.TreeView(self.__model)
        scrolled_window.add_with_viewport(tree_view)
        tree_view.show()
        cell = gtk.CellRendererText()
        column1 = gtk.TreeViewColumn("Nummer", cell, text=0)
        tree_view.append_column(column1)
        column2 = gtk.TreeViewColumn("Titel", cell, text=1)
        tree_view.append_column(column2)
        return scrolled_window

    def create_notebook(self):
        notebook = gtk.Notebook()
        frame1 = gtk.Frame("Test1")
        l1 = gtk.Label(unicode("Hinzufgen", "latin-1"))
        table = gtk.Table(4, 2, False)
        frame1.add(table)
        l2 = gtk.Label("Nummer")
        table.attach(l2, 0, 1, 0, 1)
        adj = gtk.Adjustment(10, 1, 10000, 1, 15, 0)
        self.__s1 = gtk.SpinButton(adj)
        table.attach(self.__s1, 1, 2, 0, 1)
        l3 = gtk.Label("Titel")
        table.attach(l3, 0, 1, 1, 2)
        self.__e1 = gtk.Entry()
        table.attach(self.__e1, 1, 2, 1, 2)
        l4 = gtk.Label("Handlung")
        table.attach(l4, 0, 1, 2, 3)
        self.__t1 = gtk.TextView()
        table.attach(self.__t1, 1, 2, 2, 3)
        b1 = gtk.Button(unicode("Hinzufgen", "latin-1"), gtk.STOCK_OK)
        b1.connect("clicked", self.__eintragen)
        table.attach(b1, 0, 1, 3, 4)
        notebook.append_page(frame1, l1)
        frame2 = gtk.Frame("Test2")
        l5 = gtk.Label("Finden")
        table2 = gtk.Table(2, 2, True)
        frame2.add(table2)
        l6 = gtk.Label("Suchstring")
        table2.attach(l6, 0, 1, 0, 1)
        self.__e2 = gtk.Entry()
        table2.attach(self.__e2, 1, 2, 0, 1)
        b2 = gtk.Button(unicode("Finden", "latin-1"))
        table2.attach(b2, 0, 1, 1, 2)
        notebook.append_page(frame2, l5)
        return notebook


fenster = Fenster()
